import { createDefaultModule, DefaultModuleContext, inject, LangiumServices, Module, PartialLangiumServices } from 'langium';
import { LangiumNameTestGeneratedModule } from './generated/module';
import { LangiumNameTestValidationRegistry, LangiumNameTestValidator } from './langium-name-test-validator';

/**
 * Declaration of custom services - add your own service classes here.
 */
export type LangiumNameTestAddedServices = {
    validation: {
        LangiumNameTestValidator: LangiumNameTestValidator
    }
}

/**
 * Union of Langium default services and your custom services - use this as constructor parameter
 * of custom service classes.
 */
export type LangiumNameTestServices = LangiumServices & LangiumNameTestAddedServices

/**
 * Dependency injection module that overrides Langium default services and contributes the
 * declared custom services. The Langium defaults can be partially specified to override only
 * selected services, while the custom services must be fully specified.
 */
export const LangiumNameTestModule: Module<LangiumNameTestServices, PartialLangiumServices & LangiumNameTestAddedServices> = {
    validation: {
        ValidationRegistry: (injector) => new LangiumNameTestValidationRegistry(injector),
        LangiumNameTestValidator: () => new LangiumNameTestValidator()
    }
};

/**
 * Inject the full set of language services by merging three modules:
 *  - Langium default services
 *  - Services generated by langium-cli
 *  - Services specified in this file
 */
export function createLangiumNameTestServices(context?: DefaultModuleContext): LangiumNameTestServices {
    return inject(
        createDefaultModule(context),
        LangiumNameTestGeneratedModule,
        LangiumNameTestModule
    );
}
